/*****************************************************************************
 *
 * This program is free software ; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 * $Id: file.h 131 2004-12-04 20:36:04Z picard $
 *
 * BetaPlayer Core
 * Copyright (c) 2004 Gabor Kovacs
 *
 ****************************************************************************/

#ifndef __FILE_H
#define __FILE_H

//---------------------------------------------------------------
// file

#define FILE_ID			FOURCC('F','I','L','E')

extern DLL void File_Init();
extern DLL void File_Done();

typedef void* file;

extern DLL file FileOpen( const tchar_t*, bool_t Write ); 
extern DLL int FileRead( file, void*, int );
extern DLL int FileWrite( file, const void*, int );
extern DLL void FilePrintf( file, const tchar_t*,...);
extern DLL int FileSeek( file, int, int );
extern DLL void FileClose( file );

#endif
