/*****************************************************************************
 *
 * This program is free software ; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 * $Id: idct.c 131 2004-12-04 20:36:04Z picard $
 *
 * BetaPlayer Core
 * Copyright (c) 2004 Gabor Kovacs
 *
 ****************************************************************************/

#include "stdafx.h"

const datadef IDCTParams[] = 
{
	{ IDCT_CLASS,		TYPE_CLASS },
	{ IDCT_ROUNDING,	TYPE_BOOL, DF_HIDDEN },
	{ IDCT_NATIVEFORMAT,TYPE_INT, DF_HIDDEN|DF_SETUP|DF_RDONLY },
	{ IDCT_FORMAT,		TYPE_INT, DF_HIDDEN },
	{ IDCT_BUFFERCOUNT,	TYPE_INT },
	{ IDCT_OUTPUT,		TYPE_PIN, DF_OUTPUT, PACKET_VIDEO },

	DATADEF_END
};

static void EmptyProcess(void* This,int x,int y) {}
static void EmptyCopy(void* This,int x,int y,int Forward) {}
static void EmptyMComp(void* This,const int *MVBack,const int *MVFwd) {}
static void EmptyIntra(void* This,void* Data,int Length,int ScanType) {}
static void EmptyInter(void* This,void* Data,int Length) {}

void IDCTSetEmpty(idct* p)
{
	p->Process = EmptyProcess;
	p->Copy16x16 = EmptyCopy;
	p->MComp16x16 = EmptyMComp;
	p->MComp8x8 = EmptyMComp;
	p->Intra8x8 = EmptyIntra;
	p->Inter8x8 = EmptyInter;
}