/*****************************************************************************
 *
 * This program is free software ; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 * $Id: stdafx.c 131 2004-12-04 20:36:04Z picard $
 *
 * BetaPlayer Core
 * Copyright (c) 2004 Gabor Kovacs
 *
 ****************************************************************************/

#include "stdafx.h"
#include "dyncode/dyncode.h"
#include "pcm/pcm_soft.h"
#include "pcm/law.h"
#include "pcm/adpcm.h"
#include "blit/blit_soft.h"
#include "softidct/softidct.h"

#ifdef COMMON_EXPORTS

LIBGCC

int DLLRegister(int Version)
{
	if (Version != NODE_VERSION) 
		return ERR_NOT_COMPATIBLE;
	SysTimer_Init();
	SoftIDCT_Init(SOFTIDCT_ID,0);
	File_Init();
	HTTP_Init();
	WaveOut_Init();
	NullAudio_Init();
	NullVideo_Init();
	Law_Init();
	ADPCM_Init();
	return ERR_NONE;
}

void DLLUnRegister()
{
	SysTimer_Done();
	SoftIDCT_Done();
	File_Done();
	HTTP_Done();
	WaveOut_Done();
	NullAudio_Done();
	NullVideo_Done();
	Law_Done();
	ADPCM_Done();
}

#endif
