/*****************************************************************************
 *
 * This program is free software ; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 * $Id: str.h 69 2004-10-04 19:04:31Z picard $
 *
 * BetaPlayer Core
 * Copyright (c) 2004 Gabor Kovacs
 *
 ****************************************************************************/

#ifndef __STDFILE_H
#define __STDFILE_H

#undef ferror
#define fread(ptr,n,m,f) FileRead(f,ptr,(n)*(m))
#define fwrite(ptr,n,m,f) FileWrite(f,ptr,(n)*(m))
#define fclose(f) FileClose(f)
#define fseek(f,ofs,mode) FileSeek(f,ofs,mode)
#define ftell(f) FileSeek(f,0,SEEK_CUR)
#define fflush(f)
#define ferror(f) (0)
#define clearerr(f) (0)
#define fputc(ch,f) { int i=(ch); FileWrite(f,&i,1); }
#define fprintf FilePrintf

#ifdef UNICODE
#define _wfopen(name,mode) (FILE*)FileOpen(name,wcschr((mode),'r')==NULL)
extern void FilePrintf( void*, const short*,...);
#else
#define fopen(name,mode) (FILE*)FileOpen(name,strchr((mode),'r')==NULL)
extern void FilePrintf( void*, const char*,...);
#endif

#endif

