/*****************************************************************************
 *
 * This code has been developed by Project Mayo. This software is an
 * implementation of a part of one or more MPEG-4 Video tools as
 * specified in ISO/IEC 14496-2 standard.  Those intending to use this
 * software module in hardware or software products are advised that its
 * use may infringe existing patents or copyrights, and any such use
 * would be at such party's own risk.  The original developer of this
 * software module and his/her company, and subsequent editors and their
 * companies (including Project Mayo), will have no liability for use of
 * this software or modifications or derivatives thereof.
 *
 *****************************************************************************
 *																				*	
 * This program is free software ; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 * $Id: mp4_vld.h 48 2004-09-26 05:16:45Z picard $
 *
 *****************************************************************************
 *
 * Authors:
 *
 *	John	Funnell   (JF) and
 *	Andrea	Graziani  (Ag): Original source code (Open Divx Decoder 0.4a).
 *	Marc	Dukette   (Md) and
 *	Pedro	Mateu     (Pm) and
 *	Gabor	Kovacs    (Kg) Heavily modified and optimized code
 *
 ****************************************************************************/

#ifndef _MP4_VLD_H_
#define _MP4_VLD_H_

extern _CONST uint16_t vld_intra[];
extern _CONST uint16_t vld_inter[];

extern int vld_block_h263( mp4_decode* dec, const uint16_t *table, const uint8_t *scan, int len ); 
extern int vld_block_mpeg( mp4_decode* dec, const uint16_t *table, const uint8_t *scan, int len ); 

#define TABLE_1			0
#define TABLE_2			112
#define TABLE_3			112+96
#define TABLE_LMAX		112+96+120
#define TABLE_RMAX		112+96+120+64

#define vld_code								\
	code = showbits_pos(dec,12);				\
	if (code >> 9)								\
		code = (code >> 5) - 16 + TABLE_1;		\
	else if (code >> 7)							\
		code = (code >> 2) - 32 + TABLE_2;		\
	else /* if (code >= 8)  but we don't care about invalid huffman codes */ \
		code = code - 8 + TABLE_3;				\
	code = table[code];							\
	flushbits_pos(dec,code >> 12);

#endif
