/*****************************************************************************
 *
 * This program is free software ; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 * $Id: overlay_direct.c 131 2004-12-04 20:36:04Z picard $
 *
 * BetaPlayer Overlay plugin
 * Copyright (c) 2004 Gabor Kovacs
 *
 ****************************************************************************/

#include "stdafx.h"

typedef struct direct
{
	overlay_base p;
	planes Planes;
	bool_t KernelMode;

} direct;

static int Init(direct* p)
{
	p->Planes[0] = LockFrameBuffer(&p->p.Output);
	p->p.SetFX = BLITFX_AVOIDTEARING;
	OvlAdjustOrientation(&p->p,0);
	return ERR_NONE;
}

static int Reset(direct* p)
{
	UnlockFrameBuffer();
	p->Planes[0] = LockFrameBuffer(&p->p.Output);
	return ERR_NONE;
}

static void Done(direct* p)
{
	UnlockFrameBuffer();
}

static int Lock(direct* p, planes Planes, bool_t OnlyAligned )
{
	p->KernelMode = KernelMode(1);
	Planes[0] = p->Planes[0];
	return ERR_NONE;
}

static int Unlock(direct* p )
{
	KernelMode(p->KernelMode);
	return ERR_NONE;
}

static direct Direct = 
{
	OvlEnum,
	OvlGet,
	OvlSet,
	Init,
	Done,
	OvlBlitImage,
	OvlUpdateAlign,
	NULL, //updateshow
	NULL, //queryorientation
	Reset,
	NULL, //updatewnd
	Lock,
	Unlock,
};

void Direct_Init()
{ 
	video p;
	if (LockFrameBuffer(&p))
	{
		UnlockFrameBuffer();
		OvlInit(&Direct.p,DIRECT_ID,0,PRI_DEFAULT+90);
	}
}

void Direct_Done()
{
	OvlDone(&Direct.p);
}
