/*****************************************************************************
 *
 * This program is free software ; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 * $Id: about.c 144 2004-12-12 15:28:39Z picard $
 *
 * BetaPlayer
 * Copyright (c) 2004 Gabor Kovacs
 *
 ****************************************************************************/

#include "stdafx.h"
#include <shellapi.h>

#define COPYRIGHT T("Copyright (C) 2004")
#define AUTHORS T(" - Gabor Kovacs\n - Pedro Mateu (MIPS idct)")

static bool_t Proc(win* Win,int Msg, WPARAM wParam, LPARAM lParam, int* Result)
{
	tchar_t s[512]; 
	const tchar_t* Translate;
	int y;

	switch (Msg)
	{
	case WM_COMMAND:
		if (LOWORD(wParam) == PLATFORM_OK)
			PostMessage(Win->Wnd,WM_CLOSE,0,0);

		if (LOWORD(wParam) == ABOUT_COPYRIGHT)
		{
			SHELLEXECUTEINFO Info;
			tchar_t Path[MAXPATH];
			tchar_t* p;
			
			GetModuleFileName(NULL,Path,MAXPATH);
			p = tcsrchr(Path,'\\');
			if (!p++) p=Path;
			tcscpy(p,T("betaplayer.htm"));

			memset(&Info,0,sizeof(Info));
			Info.cbSize = sizeof(Info);
			Info.lpFile = Path;
			Info.nShow = SW_SHOW;

			ShellExecuteEx(&Info);
		}

		if (LOWORD(wParam) == ABOUT_DUMP)
			Dump();
		break;

	case WM_CREATE:

		WinCreateDialog(Win);

		stprintf(s,String(ABOUT_ID,ABOUT_TITLE),NodeProgramId());
		SetWindowText(Win->Wnd,s);

		stprintf(s,String(ABOUT_ID,ABOUT_HEAD),NodeProgramId(),NodeVersion());
		y = WinLabel(Win,4,2,Win->DlgWidth-4,s,14,LABEL_BOLD|LABEL_CENTER,NULL);
		y = WinLabel(Win,y,2,Win->DlgWidth-4,COPYRIGHT,11,LABEL_CENTER,NULL);

		Translate = String(ABOUT_ID,ABOUT_TRANSLATION);
		if (Translate[0])
			y = WinLabel(Win,y+6,2,Win->DlgWidth-4,Translate,11,LABEL_CENTER|LABEL_BOLD,NULL);

		y = WinLabel(Win,y+7,2,Win->DlgWidth-4,String(ABOUT_ID,ABOUT_LICENSE),11,0,NULL);
		y = WinLabel(Win,y+3,2,Win->DlgWidth-4,String(ABOUT_ID,ABOUT_LIBSUSED),11,0,NULL);
		y = WinLabel(Win,y,2,Win->DlgWidth-4,String(ABOUT_ID,ABOUT_LIBS),11,LABEL_BOLD,NULL);
		y = WinLabel(Win,y+3,2,Win->DlgWidth-4,String(ABOUT_ID,ABOUT_AUTHORS),11,0,NULL);
		y = WinLabel(Win,y,2,Win->DlgWidth-4,AUTHORS,11,LABEL_BOLD,NULL);
		y = WinLabel(Win,y+3,2,Win->DlgWidth-4,String(ABOUT_ID,ABOUT_THANKS),11,0,NULL);
		y = WinLabel(Win,y,2,Win->DlgWidth-4,String(ABOUT_ID,ABOUT_THANKSLIBS),11,LABEL_BOLD,NULL);
		y = WinLabel(Win,y+3,2,Win->DlgWidth-4,String(ABOUT_ID,ABOUT_FORUM),11,0,NULL);
		break;
	}
	return 0;
}

static menudef MenuDef[] =
{
	{ 0, PLATFORM_ID, PLATFORM_OK },
	{ 0, ABOUT_ID, ABOUT_DUMP },
	{ 0, ABOUT_ID, ABOUT_COPYRIGHT },
	
	MENUDEF_END
};

static menudef MenuDefSmart[] =
{
	{ 0, PLATFORM_ID, PLATFORM_OK },
	{ 0, ABOUT_ID, ABOUT_OPTIONS },
	{ 1, ABOUT_ID, ABOUT_DUMP },
	{ 1, ABOUT_ID, ABOUT_COPYRIGHT },
	
	MENUDEF_END
};

static win About;

void About_Init()
{
	memset(&About,0,sizeof(About));
	About.Id = ABOUT_ID;
	About.Width = 240;
	About.Height = 320;
	About.Dialog = 1;
	About.MenuDef = QueryPlatform(PLATFORM_TYPENO) == TYPE_SMARTPHONE ? MenuDefSmart : MenuDef;
	About.Proc = Proc;
	WinRegister(&About,PRI_DEFAULT);
}

void About_Done()
{
	WinUnRegister(&About);
}