/*****************************************************************************
 *
 * This program is free software ; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 * $Id: interface.h 131 2004-12-04 20:36:04Z picard $
 *
 * BetaPlayer
 * Copyright (c) 2004 Gabor Kovacs
 *
 ****************************************************************************/

#ifndef __INTERFACE_H
#define __INTERFACE_H

extern void Interface_Init();
extern void Interface_Done();

#define INTERFACE_ID					FOURCC('I','N','T','F')

#define INTERFACE_ERROR					0x100

#define MAXCMD							1024

#define MSG_OPEN						WM_APP + 0x200
#define MSG_INIT						WM_APP + 0x201
#define MSG_WAIT						WM_APP + 0x202
#define MSG_ERROR						WM_APP + 0x203
#define MSG_FULLSCREEN					WM_APP + 0x204
#define MSG_UPDATE						WM_APP + 0x205

#define IF_REG_OPEN						1000
#define IF_REG_INITING					1001

#define IF_ALL_TYPES					202

#define IF_OPTIONS						221
#define IF_OPTIONS_SPEED				205
#define IF_OPTIONS_REPEAT			    306
#define IF_OPTIONS_SHUFFLE			    307
#define	IF_OPTIONS_ZOOM					207
#define IF_OPTIONS_ZOOM_FIT_SCREEN		312
#define IF_OPTIONS_ZOOM_FIT_WIDTH		0x207
#define IF_OPTIONS_ZOOM_FIT_HEIGHT		0x206
#define IF_OPTIONS_ZOOM_FIT_110			0x234
#define IF_OPTIONS_ZOOM_FIT_120			0x235
#define IF_OPTIONS_ZOOM_FIT_130			0x236
#define IF_OPTIONS_ZOOM_FIT_140			0x237
#define IF_OPTIONS_ZOOM_50				313
#define IF_OPTIONS_ZOOM_100				314
#define IF_OPTIONS_ZOOM_150				398
#define IF_OPTIONS_ZOOM_200				315
#define IF_OPTIONS_VIDEO				210
#define IF_OPTIONS_VIDEO_DITHER         308
#define IF_OPTIONS_VIDEO_ZOOM_SMOOTH50	316
#define IF_OPTIONS_VIDEO_ZOOM_SMOOTHALWAYS 0x22A
#define IF_OPTIONS_AUDIO				211
#define IF_OPTIONS_AUDIO_SWAPSTEREO     320
#define IF_OPTIONS_AUDIO_QUALITY_LOW    324
#define IF_OPTIONS_AUDIO_QUALITY_MEDIUM 325
#define IF_OPTIONS_AUDIO_QUALITY_HIGH   326
#define IF_OPTIONS_SPEED_10	            222
#define IF_OPTIONS_SPEED_25             333
#define IF_OPTIONS_SPEED_50             334
#define IF_OPTIONS_SPEED_80             0x230
#define IF_OPTIONS_SPEED_90             0x231
#define IF_OPTIONS_SPEED_100            335
#define IF_OPTIONS_SPEED_110            0x232
#define IF_OPTIONS_SPEED_120            0x233
#define IF_OPTIONS_SPEED_150            206
#define IF_OPTIONS_SPEED_200            340
#define IF_OPTIONS_SPEED_300            341
#define IF_OPTIONS_SPEED_BENCHMARK      342
#define IF_OPTIONS_VIDEO_TURNOFF        343
#define IF_OPTIONS_AUDIO_TURNOFF        344
#define IF_OPTIONS_FULLSCREEN           383
#define IF_OPTIONS_MUTE                 384
#define IF_OPTIONS_SETTINGS             375
#define IF_OPTIONS_ORIENTATION			208
#define IF_OPTIONS_ORIENTATION_FULLSCREEN 209
#define IF_OPTIONS_ROTATE_90            389
#define IF_OPTIONS_ROTATE_180           390
#define IF_OPTIONS_ROTATE_0             392
#define IF_OPTIONS_ROTATE_270           393
#define IF_OPTIONS_ROTATE				240
#define IF_OPTIONS_VIDEO_DEVICE         395
#define IF_OPTIONS_VIDEO_ACCEL          231
#define IF_OPTIONS_AUDIO_DEVICE         396
#define IF_OPTIONS_AUDIO_QUALITY        397
#define IF_OPTIONS_VOLUME_UP			243
#define IF_OPTIONS_VOLUME_DOWN			244
#define IF_OPTIONS_BRIGHTNESS_UP		245
#define IF_OPTIONS_BRIGHTNESS_DOWN		246
#define IF_OPTIONS_CONTRAST_UP			247
#define IF_OPTIONS_CONTRAST_DOWN		248
#define IF_OPTIONS_SATURATION_UP		258
#define IF_OPTIONS_SATURATION_DOWN		257
#define IF_OPTIONS_SCREEN				249
#define IF_OPTIONS_EQUALIZER			290
#define IF_OPTIONS_VIDEO_STREAM			0x201
#define IF_OPTIONS_VIDEO_STREAM_NONE	0x221
#define IF_OPTIONS_AUDIO_STREAM			0x202
#define IF_OPTIONS_AUDIO_STREAM_NONE	0x222
#define IF_OPTIONS_AUDIO_CHANNELS		0x216
#define IF_OPTIONS_AUDIO_STEREO			0x203
#define IF_OPTIONS_AUDIO_MONO_LEFT		0x204
#define IF_OPTIONS_AUDIO_MONO_RIGHT		0x205
#define IF_OPTIONS_VIEW					0x20E
#define IF_OPTIONS_VIEW_TITLEBAR		0x240
#define IF_OPTIONS_VIEW_TRACKBAR		0x241
#define IF_OPTIONS_VIEW					0x20E
#define IF_OPTIONS_ASPECT				0x20F
#define IF_OPTIONS_ASPECT_SQUARE		0x210
#define IF_OPTIONS_ASPECT_4_3_PAL		0x211
#define IF_OPTIONS_ASPECT_4_3_NTSC		0x212
#define IF_OPTIONS_ASPECT_16_9_PAL		0x213
#define IF_OPTIONS_ASPECT_16_9_NTSC		0x214
#define IF_OPTIONS_ASPECT_AUTO			0x215
#define IF_OPTIONS_ZOOM_FIT				0x224
#define IF_OPTIONS_ZOOM_IN				0x225
#define IF_OPTIONS_ZOOM_OUT				0x226
#define IF_OPTIONS_TOGGLE_VIDEO			0x227
#define IF_OPTIONS_TOGGLE_AUDIO			0x228

#define IF_FILE							220
#define IF_FILE_OPENFILE                385
#define IF_FILE_PLAYLIST                382
#define IF_FILE_MEDIAINFO               330
#define IF_FILE_ABOUT                   331
#define IF_FILE_BENCHMARK               230
#define IF_FILE_EXIT                    332
#define IF_FILE_CHAPTERS				0x200
#define IF_FILE_CHAPTERS_NONE			0x223

#define IF_PLAY                         370
#define IF_PLAY_FULLSCREEN				241
#define IF_STOP                         372
#define IF_MOVE_FFWD					250
#define IF_MOVE_BACK					251
#define IF_NEXT                         378
#define IF_PREV                         379
#define IF_FASTFORWARD                  386

#define IF_TITLEBAR						0x300
#define IF_TRACKBAR						0x301

#endif