/*****************************************************************************
 *
 * This program is free software ; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 * $Id: vorbis.h 131 2004-12-04 20:36:04Z picard $
 *
 * BetaPlayer Vorbis plugin
 * Copyright (c) 2004 Gabor Kovacs
 *
 ****************************************************************************/
 
#ifndef __VORBIS_H
#define __VORBIS_H

#define OGGEMBEDDED_ID		FOURCC('O','G','G','E')

extern void OGGEmbedded_Init();
extern void OGGEmbedded_Done();

#define OGGPACKET_ID		FOURCC('O','G','G','P')

extern void OGGPacket_Init();
extern void OGGPacket_Done();

#define OGG_ID				FOURCC('O','G','G','V')

extern void OGG_Init();
extern void OGG_Done();

#define VORBIS_ID			FOURCC('V','O','R','B')

extern void Vorbis_Init();
extern void Vorbis_Done();

#define AUDIOFMT_VORBIS_INTERNAL	0x1674F
#define AUDIOFMT_VORBIS_PACKET		0x2674F

#define AUDIOFMT_VORBIS_MODE1		0x674F
#define AUDIOFMT_VORBIS_MODE1P		0x676F
#define AUDIOFMT_VORBIS_MODE2		0x6750
#define AUDIOFMT_VORBIS_MODE2P		0x6770
#define AUDIOFMT_VORBIS_MODE3		0x6751
#define AUDIOFMT_VORBIS_MODE3P		0x6771

#endif
